generate_config.sh 21 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556
  1. #!/usr/bin/env bash
  2. set -o pipefail
  3. if [[ "$(uname -r)" =~ ^4\.15\.0-60 ]]; then
  4. echo "DO NOT RUN mailcow ON THIS UBUNTU KERNEL!";
  5. echo "Please update to 5.x or use another distribution."
  6. exit 1
  7. fi
  8. if [[ "$(uname -r)" =~ ^4\.4\. ]]; then
  9. if grep -q Ubuntu <<< $(uname -a); then
  10. echo "DO NOT RUN mailcow ON THIS UBUNTU KERNEL!";
  11. echo "Please update to linux-generic-hwe-16.04 by running \"apt-get install --install-recommends linux-generic-hwe-16.04\""
  12. exit 1
  13. fi
  14. fi
  15. if grep --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox grep detected, please install gnu grep, \"apk add --no-cache --upgrade grep\""; exit 1; fi
  16. # This will also cover sort
  17. if cp --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox cp detected, please install coreutils, \"apk add --no-cache --upgrade coreutils\""; exit 1; fi
  18. if sed --help 2>&1 | head -n 1 | grep -q -i "busybox"; then echo "BusyBox sed detected, please install gnu sed, \"apk add --no-cache --upgrade sed\""; exit 1; fi
  19. for bin in openssl curl docker git awk sha1sum grep cut; do
  20. if [[ -z $(which ${bin}) ]]; then echo "Cannot find ${bin}, exiting..."; exit 1; fi
  21. done
  22. if docker compose > /dev/null 2>&1; then
  23. if docker compose version --short | grep "^2." > /dev/null 2>&1; then
  24. COMPOSE_VERSION=native
  25. echo -e "\e[33mFound Docker Compose Plugin (native).\e[0m"
  26. echo -e "\e[33mSetting the DOCKER_COMPOSE_VERSION Variable to native\e[0m"
  27. sleep 2
  28. echo -e "\e[33mNotice: You´ll have to update this Compose Version via your Package Manager manually!\e[0m"
  29. else
  30. echo -e "\e[31mCannot find Docker Compose with a Version Higher than 2.X.X.\e[0m"
  31. echo -e "\e[31mPlease update/install it manually regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  32. exit 1
  33. fi
  34. elif docker-compose > /dev/null 2>&1; then
  35. if ! [[ $(alias docker-compose 2> /dev/null) ]] ; then
  36. if docker-compose version --short | grep "^2." > /dev/null 2>&1; then
  37. COMPOSE_VERSION=standalone
  38. echo -e "\e[33mFound Docker Compose Standalone.\e[0m"
  39. echo -e "\e[33mSetting the DOCKER_COMPOSE_VERSION Variable to standalone\e[0m"
  40. sleep 2
  41. echo -e "\e[33mNotice: For an automatic update of docker-compose please use the update_compose.sh scripts located at the helper-scripts folder.\e[0m"
  42. else
  43. echo -e "\e[31mCannot find Docker Compose with a Version Higher than 2.X.X.\e[0m"
  44. echo -e "\e[31mPlease update/install manually regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  45. exit 1
  46. fi
  47. fi
  48. else
  49. echo -e "\e[31mCannot find Docker Compose.\e[0m"
  50. echo -e "\e[31mPlease install it regarding to this doc site: https://docs.mailcow.email/i_u_m/i_u_m_install/\e[0m"
  51. exit 1
  52. fi
  53. detect_bad_asn() {
  54. echo -e "\e[33mDetecting if your IP is listed on Spamhaus Bad ASN List...\e[0m"
  55. response=$(curl --connect-timeout 15 --max-time 30 -s -o /dev/null -w "%{http_code}" "https://asn-check.mailcow.email")
  56. if [ "$response" -eq 503 ]; then
  57. if [ -z "$SPAMHAUS_DQS_KEY" ]; then
  58. echo -e "\e[33mYour server's public IP uses an AS that is blocked by Spamhaus to use their DNS public blocklists for Postfix.\e[0m"
  59. echo -e "\e[33mmailcow did not detected a value for the variable SPAMHAUS_DQS_KEY inside mailcow.conf!\e[0m"
  60. sleep 2
  61. echo ""
  62. echo -e "\e[33mTo use the Spamhaus DNS Blocklists again, you will need to create a FREE account for their Data Query Service (DQS) at: https://www.spamhaus.com/free-trial/sign-up-for-a-free-data-query-service-account\e[0m"
  63. echo -e "\e[33mOnce done, enter your DQS API key in mailcow.conf and mailcow will do the rest for you!\e[0m"
  64. echo ""
  65. sleep 2
  66. else
  67. echo -e "\e[33mYour server's public IP uses an AS that is blocked by Spamhaus to use their DNS public blocklists for Postfix.\e[0m"
  68. echo -e "\e[32mmailcow detected a Value for the variable SPAMHAUS_DQS_KEY inside mailcow.conf. Postfix will use DQS with the given API key...\e[0m"
  69. fi
  70. elif [ "$response" -eq 200 ]; then
  71. echo -e "\e[33mCheck completed! Your IP is \e[32mclean\e[0m"
  72. elif [ "$response" -eq 429 ]; then
  73. echo -e "\e[33mCheck completed! \e[31mYour IP seems to be rate limited on the ASN Check service... please try again later!\e[0m"
  74. else
  75. echo -e "\e[31mCheck failed! \e[0mMaybe a DNS or Network problem?\e[0m"
  76. fi
  77. }
  78. ### If generate_config.sh is started with --dev or -d it will not check out nightly or master branch and will keep on the current branch
  79. if [[ ${1} == "--dev" || ${1} == "-d" ]]; then
  80. SKIP_BRANCH=y
  81. else
  82. SKIP_BRANCH=n
  83. fi
  84. if [ -f mailcow.conf ]; then
  85. read -r -p "A config file exists and will be overwritten, are you sure you want to continue? [y/N] " response
  86. case $response in
  87. [yY][eE][sS]|[yY])
  88. mv mailcow.conf mailcow.conf_backup
  89. chmod 600 mailcow.conf_backup
  90. ;;
  91. *)
  92. exit 1
  93. ;;
  94. esac
  95. fi
  96. echo "Press enter to confirm the detected value '[value]' where applicable or enter a custom value."
  97. while [ -z "${MAILCOW_HOSTNAME}" ]; do
  98. read -p "Mail server hostname (FQDN) - this is not your mail domain, but your mail servers hostname: " -e MAILCOW_HOSTNAME
  99. DOTS=${MAILCOW_HOSTNAME//[^.]};
  100. if [ ${#DOTS} -lt 1 ]; then
  101. echo -e "\e[31mMAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) is not a FQDN!\e[0m"
  102. sleep 1
  103. echo "Please change it to a FQDN and redeploy the stack with docker(-)compose up -d"
  104. exit 1
  105. elif [[ "${MAILCOW_HOSTNAME: -1}" == "." ]]; then
  106. echo "MAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) is ending with a dot. This is not a valid FQDN!"
  107. exit 1
  108. elif [ ${#DOTS} -eq 1 ]; then
  109. echo -e "\e[33mMAILCOW_HOSTNAME (${MAILCOW_HOSTNAME}) does not contain a Subdomain. This is not fully tested and may cause issues.\e[0m"
  110. echo "Find more information about why this message exists here: https://github.com/mailcow/mailcow-dockerized/issues/1572"
  111. read -r -p "Do you want to proceed anyway? [y/N] " response
  112. if [[ "$response" =~ ^([yY][eE][sS]|[yY])+$ ]]; then
  113. echo "OK. Procceding."
  114. else
  115. echo "OK. Exiting."
  116. exit 1
  117. fi
  118. fi
  119. done
  120. if [ -a /etc/timezone ]; then
  121. DETECTED_TZ=$(cat /etc/timezone)
  122. elif [ -a /etc/localtime ]; then
  123. DETECTED_TZ=$(readlink /etc/localtime|sed -n 's|^.*zoneinfo/||p')
  124. fi
  125. while [ -z "${MAILCOW_TZ}" ]; do
  126. if [ -z "${DETECTED_TZ}" ]; then
  127. read -p "Timezone: " -e MAILCOW_TZ
  128. else
  129. read -p "Timezone [${DETECTED_TZ}]: " -e MAILCOW_TZ
  130. [ -z "${MAILCOW_TZ}" ] && MAILCOW_TZ=${DETECTED_TZ}
  131. fi
  132. done
  133. MEM_TOTAL=$(awk '/MemTotal/ {print $2}' /proc/meminfo)
  134. if [ ${MEM_TOTAL} -le "2621440" ]; then
  135. echo "Installed memory is <= 2.5 GiB. It is recommended to disable ClamAV to prevent out-of-memory situations."
  136. echo "ClamAV can be re-enabled by setting SKIP_CLAMD=n in mailcow.conf."
  137. read -r -p "Do you want to disable ClamAV now? [Y/n] " response
  138. case $response in
  139. [nN][oO]|[nN])
  140. SKIP_CLAMD=n
  141. ;;
  142. *)
  143. SKIP_CLAMD=y
  144. ;;
  145. esac
  146. else
  147. SKIP_CLAMD=n
  148. fi
  149. if [ ${MEM_TOTAL} -le "2097152" ]; then
  150. echo "Disabling Solr on low-memory system."
  151. SKIP_SOLR=y
  152. elif [ ${MEM_TOTAL} -le "3670016" ]; then
  153. echo "Installed memory is <= 3.5 GiB. It is recommended to disable Solr to prevent out-of-memory situations."
  154. echo "Solr is a prone to run OOM and should be monitored. The default Solr heap size is 1024 MiB and should be set in mailcow.conf according to your expected load."
  155. echo "Solr can be re-enabled by setting SKIP_SOLR=n in mailcow.conf but will refuse to start with less than 2 GB total memory."
  156. read -r -p "Do you want to disable Solr now? [Y/n] " response
  157. case $response in
  158. [nN][oO]|[nN])
  159. SKIP_SOLR=n
  160. ;;
  161. *)
  162. SKIP_SOLR=y
  163. ;;
  164. esac
  165. else
  166. SKIP_SOLR=n
  167. fi
  168. if [[ ${SKIP_BRANCH} != y ]]; then
  169. echo "Which branch of mailcow do you want to use?"
  170. echo ""
  171. echo "Available Branches:"
  172. echo "- master branch (stable updates) | default, recommended [1]"
  173. echo "- nightly branch (unstable updates, testing) | not-production ready [2]"
  174. sleep 1
  175. while [ -z "${MAILCOW_BRANCH}" ]; do
  176. read -r -p "Choose the Branch with it´s number [1/2] " branch
  177. case $branch in
  178. [2])
  179. MAILCOW_BRANCH="nightly"
  180. ;;
  181. *)
  182. MAILCOW_BRANCH="master"
  183. ;;
  184. esac
  185. done
  186. git fetch --all
  187. git checkout -f $MAILCOW_BRANCH
  188. elif [[ ${SKIP_BRANCH} == y ]]; then
  189. echo -e "\033[33mEnabled Dev Mode.\033[0m"
  190. echo -e "\033[33mNot checking out a different branch!\033[0m"
  191. MAILCOW_BRANCH=$(git rev-parse --short $(git rev-parse @{upstream}))
  192. else
  193. echo -e "\033[31mCould not determine branch input..."
  194. echo -e "\033[31mExiting."
  195. exit 1
  196. fi
  197. if [ ! -z "${MAILCOW_BRANCH}" ]; then
  198. git_branch=${MAILCOW_BRANCH}
  199. fi
  200. [ ! -f ./data/conf/rspamd/override.d/worker-controller-password.inc ] && echo '# Placeholder' > ./data/conf/rspamd/override.d/worker-controller-password.inc
  201. cat << EOF > mailcow.conf
  202. # ------------------------------
  203. # mailcow web ui configuration
  204. # ------------------------------
  205. # example.org is _not_ a valid hostname, use a fqdn here.
  206. # Default admin user is "admin"
  207. # Default password is "moohoo"
  208. MAILCOW_HOSTNAME=${MAILCOW_HOSTNAME}
  209. # Password hash algorithm
  210. # Only certain password hash algorithm are supported. For a fully list of supported schemes,
  211. # see https://docs.mailcow.email/models/model-passwd/
  212. MAILCOW_PASS_SCHEME=BLF-CRYPT
  213. # ------------------------------
  214. # SQL database configuration
  215. # ------------------------------
  216. DBNAME=mailcow
  217. DBUSER=mailcow
  218. # Please use long, random alphanumeric strings (A-Za-z0-9)
  219. DBPASS=$(LC_ALL=C </dev/urandom tr -dc A-Za-z0-9 2> /dev/null | head -c 28)
  220. DBROOT=$(LC_ALL=C </dev/urandom tr -dc A-Za-z0-9 2> /dev/null | head -c 28)
  221. # ------------------------------
  222. # HTTP/S Bindings
  223. # ------------------------------
  224. # You should use HTTPS, but in case of SSL offloaded reverse proxies:
  225. # Might be important: This will also change the binding within the container.
  226. # If you use a proxy within Docker, point it to the ports you set below.
  227. # Do _not_ use IP:PORT in HTTP(S)_BIND or HTTP(S)_PORT
  228. # IMPORTANT: Do not use port 8081, 9081 or 65510!
  229. # Example: HTTP_BIND=1.2.3.4
  230. # For IPv4 leave it as it is: HTTP_BIND= & HTTPS_PORT=
  231. # For IPv6 see https://docs.mailcow.email/post_installation/firststeps-ip_bindings/
  232. HTTP_PORT=80
  233. HTTP_BIND=
  234. HTTPS_PORT=443
  235. HTTPS_BIND=
  236. # ------------------------------
  237. # Other bindings
  238. # ------------------------------
  239. # You should leave that alone
  240. # Format: 11.22.33.44:25 or 12.34.56.78:465 etc.
  241. SMTP_PORT=25
  242. SMTPS_PORT=465
  243. SUBMISSION_PORT=587
  244. IMAP_PORT=143
  245. IMAPS_PORT=993
  246. POP_PORT=110
  247. POPS_PORT=995
  248. SIEVE_PORT=4190
  249. DOVEADM_PORT=127.0.0.1:19991
  250. SQL_PORT=127.0.0.1:13306
  251. SOLR_PORT=127.0.0.1:18983
  252. REDIS_PORT=127.0.0.1:7654
  253. # Your timezone
  254. # See https://en.wikipedia.org/wiki/List_of_tz_database_time_zones for a list of timezones
  255. # Use the column named 'TZ identifier' + pay attention for the column named 'Notes'
  256. TZ=${MAILCOW_TZ}
  257. # Fixed project name
  258. # Please use lowercase letters only
  259. COMPOSE_PROJECT_NAME=mailcowdockerized
  260. # Used Docker Compose version
  261. # Switch here between native (compose plugin) and standalone
  262. # For more informations take a look at the mailcow docs regarding the configuration options.
  263. # Normally this should be untouched but if you decided to use either of those you can switch it manually here.
  264. # Please be aware that at least one of those variants should be installed on your machine or mailcow will fail.
  265. DOCKER_COMPOSE_VERSION=${COMPOSE_VERSION}
  266. # Set this to "allow" to enable the anyone pseudo user. Disabled by default.
  267. # When enabled, ACL can be created, that apply to "All authenticated users"
  268. # This should probably only be activated on mail hosts, that are used exclusivly by one organisation.
  269. # Otherwise a user might share data with too many other users.
  270. ACL_ANYONE=disallow
  271. # Garbage collector cleanup
  272. # Deleted domains and mailboxes are moved to /var/vmail/_garbage/timestamp_sanitizedstring
  273. # How long should objects remain in the garbage until they are being deleted? (value in minutes)
  274. # Check interval is hourly
  275. MAILDIR_GC_TIME=7200
  276. # Additional SAN for the certificate
  277. #
  278. # You can use wildcard records to create specific names for every domain you add to mailcow.
  279. # Example: Add domains "example.com" and "example.net" to mailcow, change ADDITIONAL_SAN to a value like:
  280. #ADDITIONAL_SAN=imap.*,smtp.*
  281. # This will expand the certificate to "imap.example.com", "smtp.example.com", "imap.example.net", "smtp.example.net"
  282. # plus every domain you add in the future.
  283. #
  284. # You can also just add static names...
  285. #ADDITIONAL_SAN=srv1.example.net
  286. # ...or combine wildcard and static names:
  287. #ADDITIONAL_SAN=imap.*,srv1.example.com
  288. #
  289. ADDITIONAL_SAN=
  290. # Additional server names for mailcow UI
  291. #
  292. # Specify alternative addresses for the mailcow UI to respond to
  293. # This is useful when you set mail.* as ADDITIONAL_SAN and want to make sure mail.maildomain.com will always point to the mailcow UI.
  294. # If the server name does not match a known site, Nginx decides by best-guess and may redirect users to the wrong web root.
  295. # You can understand this as server_name directive in Nginx.
  296. # Comma separated list without spaces! Example: ADDITIONAL_SERVER_NAMES=a.b.c,d.e.f
  297. ADDITIONAL_SERVER_NAMES=
  298. # Skip running ACME (acme-mailcow, Let's Encrypt certs) - y/n
  299. SKIP_LETS_ENCRYPT=n
  300. # Create seperate certificates for all domains - y/n
  301. # this will allow adding more than 100 domains, but some email clients will not be able to connect with alternative hostnames
  302. # see https://doc.dovecot.org/admin_manual/ssl/sni_support
  303. ENABLE_SSL_SNI=n
  304. # Skip IPv4 check in ACME container - y/n
  305. SKIP_IP_CHECK=n
  306. # Skip HTTP verification in ACME container - y/n
  307. SKIP_HTTP_VERIFICATION=n
  308. # Skip ClamAV (clamd-mailcow) anti-virus (Rspamd will auto-detect a missing ClamAV container) - y/n
  309. SKIP_CLAMD=${SKIP_CLAMD}
  310. # Skip SOGo: Will disable SOGo integration and therefore webmail, DAV protocols and ActiveSync support (experimental, unsupported, not fully implemented) - y/n
  311. SKIP_SOGO=n
  312. # Skip Solr on low-memory systems or if you do not want to store a readable index of your mails in solr-vol-1.
  313. SKIP_SOLR=${SKIP_SOLR}
  314. # Solr heap size in MB, there is no recommendation, please see Solr docs.
  315. # Solr is a prone to run OOM and should be monitored. Unmonitored Solr setups are not recommended.
  316. SOLR_HEAP=1024
  317. # Allow admins to log into SOGo as email user (without any password)
  318. ALLOW_ADMIN_EMAIL_LOGIN=n
  319. # Enable watchdog (watchdog-mailcow) to restart unhealthy containers
  320. USE_WATCHDOG=y
  321. # Send watchdog notifications by mail (sent from watchdog@MAILCOW_HOSTNAME)
  322. # CAUTION:
  323. # 1. You should use external recipients
  324. # 2. Mails are sent unsigned (no DKIM)
  325. # 3. If you use DMARC, create a separate DMARC policy ("v=DMARC1; p=none;" in _dmarc.MAILCOW_HOSTNAME)
  326. # Multiple rcpts allowed, NO quotation marks, NO spaces
  327. #WATCHDOG_NOTIFY_EMAIL=a@example.com,b@example.com,c@example.com
  328. #WATCHDOG_NOTIFY_EMAIL=
  329. # Notify about banned IP (includes whois lookup)
  330. WATCHDOG_NOTIFY_BAN=n
  331. # Subject for watchdog mails. Defaults to "Watchdog ALERT" followed by the error message.
  332. #WATCHDOG_SUBJECT=
  333. # Checks if mailcow is an open relay. Requires a SAL. More checks will follow.
  334. # https://www.servercow.de/mailcow?lang=en
  335. # https://www.servercow.de/mailcow?lang=de
  336. # No data is collected. Opt-in and anonymous.
  337. # Will only work with unmodified mailcow setups.
  338. WATCHDOG_EXTERNAL_CHECKS=n
  339. # Enable watchdog verbose logging
  340. WATCHDOG_VERBOSE=n
  341. # Max log lines per service to keep in Redis logs
  342. LOG_LINES=9999
  343. # Internal IPv4 /24 subnet, format n.n.n (expands to n.n.n.0/24)
  344. # Use private IPv4 addresses only, see https://en.wikipedia.org/wiki/Private_network#Private_IPv4_addresses
  345. IPV4_NETWORK=172.22.1
  346. # Internal IPv6 subnet in fc00::/7
  347. # Use private IPv6 addresses only, see https://en.wikipedia.org/wiki/Private_network#Private_IPv6_addresses
  348. IPV6_NETWORK=fd4d:6169:6c63:6f77::/64
  349. # Use this IPv4 for outgoing connections (SNAT)
  350. #SNAT_TO_SOURCE=
  351. # Use this IPv6 for outgoing connections (SNAT)
  352. #SNAT6_TO_SOURCE=
  353. # Create or override an API key for the web UI
  354. # You _must_ define API_ALLOW_FROM, which is a comma separated list of IPs
  355. # An API key defined as API_KEY has read-write access
  356. # An API key defined as API_KEY_READ_ONLY has read-only access
  357. # Allowed chars for API_KEY and API_KEY_READ_ONLY: a-z, A-Z, 0-9, -
  358. # You can define API_KEY and/or API_KEY_READ_ONLY
  359. #API_KEY=
  360. #API_KEY_READ_ONLY=
  361. #API_ALLOW_FROM=172.22.1.1,127.0.0.1
  362. # mail_home is ~/Maildir
  363. MAILDIR_SUB=Maildir
  364. # SOGo session timeout in minutes
  365. SOGO_EXPIRE_SESSION=480
  366. # DOVECOT_MASTER_USER and DOVECOT_MASTER_PASS must both be provided. No special chars.
  367. # Empty by default to auto-generate master user and password on start.
  368. # User expands to DOVECOT_MASTER_USER@mailcow.local
  369. # LEAVE EMPTY IF UNSURE
  370. DOVECOT_MASTER_USER=
  371. # LEAVE EMPTY IF UNSURE
  372. DOVECOT_MASTER_PASS=
  373. # Let's Encrypt registration contact information
  374. # Optional: Leave empty for none
  375. # This value is only used on first order!
  376. # Setting it at a later point will require the following steps:
  377. # https://docs.mailcow.email/troubleshooting/debug-reset_tls/
  378. ACME_CONTACT=
  379. # WebAuthn device manufacturer verification
  380. # After setting WEBAUTHN_ONLY_TRUSTED_VENDORS=y only devices from trusted manufacturers are allowed
  381. # root certificates can be placed for validation under mailcow-dockerized/data/web/inc/lib/WebAuthn/rootCertificates
  382. WEBAUTHN_ONLY_TRUSTED_VENDORS=n
  383. # Spamhaus Data Query Service Key
  384. # Optional: Leave empty for none
  385. # Enter your key here if you are using a blocked ASN (OVH, AWS, Cloudflare e.g) for the unregistered Spamhaus Blocklist.
  386. # If empty, it will completely disable Spamhaus blocklists if it detects that you are running on a server using a blocked AS.
  387. # Otherwise it will work normally.
  388. SPAMHAUS_DQS_KEY=
  389. EOF
  390. mkdir -p data/assets/ssl
  391. chmod 600 mailcow.conf
  392. # copy but don't overwrite existing certificate
  393. echo "Generating snake-oil certificate..."
  394. # Making Willich more popular
  395. openssl req -x509 -newkey rsa:4096 -keyout data/assets/ssl-example/key.pem -out data/assets/ssl-example/cert.pem -days 365 -subj "/C=DE/ST=NRW/L=Willich/O=mailcow/OU=mailcow/CN=${MAILCOW_HOSTNAME}" -sha256 -nodes
  396. echo "Copying snake-oil certificate..."
  397. cp -n -d data/assets/ssl-example/*.pem data/assets/ssl/
  398. # Set app_info.inc.php
  399. case ${git_branch} in
  400. master)
  401. mailcow_git_version=$(git describe --tags `git rev-list --tags --max-count=1`)
  402. ;;
  403. nightly)
  404. mailcow_git_version=$(git rev-parse --short $(git rev-parse @{upstream}))
  405. mailcow_last_git_version=""
  406. ;;
  407. *)
  408. mailcow_git_version=$(git rev-parse --short HEAD)
  409. mailcow_last_git_version=""
  410. ;;
  411. esac
  412. # if [ ${git_branch} == "master" ]; then
  413. # mailcow_git_version=$(git describe --tags `git rev-list --tags --max-count=1`)
  414. # elif [ ${git_branch} == "nightly" ]; then
  415. # mailcow_git_version=$(git rev-parse --short $(git rev-parse @{upstream}))
  416. # mailcow_last_git_version=""
  417. # else
  418. # mailcow_git_version=$(git rev-parse --short HEAD)
  419. # mailcow_last_git_version=""
  420. # fi
  421. if [[ $SKIP_BRANCH != "y" ]]; then
  422. mailcow_git_commit=$(git rev-parse origin/${git_branch})
  423. mailcow_git_commit_date=$(git log -1 --format=%ci @{upstream} )
  424. else
  425. mailcow_git_commit=$(git rev-parse ${git_branch})
  426. mailcow_git_commit_date=$(git log -1 --format=%ci @{upstream} )
  427. git_branch=$(git rev-parse --abbrev-ref HEAD)
  428. fi
  429. if [ $? -eq 0 ]; then
  430. echo '<?php' > data/web/inc/app_info.inc.php
  431. echo ' $MAILCOW_GIT_VERSION="'$mailcow_git_version'";' >> data/web/inc/app_info.inc.php
  432. echo ' $MAILCOW_LAST_GIT_VERSION="";' >> data/web/inc/app_info.inc.php
  433. echo ' $MAILCOW_GIT_OWNER="mailcow";' >> data/web/inc/app_info.inc.php
  434. echo ' $MAILCOW_GIT_REPO="mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  435. echo ' $MAILCOW_GIT_URL="https://github.com/mailcow/mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  436. echo ' $MAILCOW_GIT_COMMIT="'$mailcow_git_commit'";' >> data/web/inc/app_info.inc.php
  437. echo ' $MAILCOW_GIT_COMMIT_DATE="'$mailcow_git_commit_date'";' >> data/web/inc/app_info.inc.php
  438. echo ' $MAILCOW_BRANCH="'$git_branch'";' >> data/web/inc/app_info.inc.php
  439. echo ' $MAILCOW_UPDATEDAT='$(date +%s)';' >> data/web/inc/app_info.inc.php
  440. echo '?>' >> data/web/inc/app_info.inc.php
  441. else
  442. echo '<?php' > data/web/inc/app_info.inc.php
  443. echo ' $MAILCOW_GIT_VERSION="'$mailcow_git_version'";' >> data/web/inc/app_info.inc.php
  444. echo ' $MAILCOW_LAST_GIT_VERSION="";' >> data/web/inc/app_info.inc.php
  445. echo ' $MAILCOW_GIT_OWNER="mailcow";' >> data/web/inc/app_info.inc.php
  446. echo ' $MAILCOW_GIT_REPO="mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  447. echo ' $MAILCOW_GIT_URL="https://github.com/mailcow/mailcow-dockerized";' >> data/web/inc/app_info.inc.php
  448. echo ' $MAILCOW_GIT_COMMIT="";' >> data/web/inc/app_info.inc.php
  449. echo ' $MAILCOW_GIT_COMMIT_DATE="";' >> data/web/inc/app_info.inc.php
  450. echo ' $MAILCOW_BRANCH="'$git_branch'";' >> data/web/inc/app_info.inc.php
  451. echo ' $MAILCOW_UPDATEDAT='$(date +%s)';' >> data/web/inc/app_info.inc.php
  452. echo '?>' >> data/web/inc/app_info.inc.php
  453. echo -e "\e[33mCannot determine current git repository version...\e[0m"
  454. fi
  455. detect_bad_asn